现在的位置: 首页 > 综合 > 正文

Codeforces Round #207 (Div. 2)C. Knight Tournament(SET也可以搞定)

2013年12月04日 ⁄ 综合 ⁄ 共 3051字 ⁄ 字号 评论关闭
C. Knight Tournament
time limit per test

3 seconds

memory limit per test

256 megabytes

input

standard input

output

standard output

Hooray! Berl II, the king of Berland is making a knight tournament. The king has already sent the message to all knights in the kingdom and they in turn agreed to participate in this grand event.

As for you, you're just a simple peasant. There's no surprise that you slept in this morning and were late for the tournament (it was a weekend, after all). Now you are really curious about the results of the tournament. This time the tournament in Berland
went as follows:

  • There are n knights participating in the tournament. Each knight was assigned his unique number — an integer from 1 to n.
  • The tournament consisted of m fights, in the i-th
    fight the knights that were still in the game with numbers at least li and
    at most rihave
    fought for the right to continue taking part in the tournament.
  • After the i-th fight among all participants of the fight only one knight won — the knight number xi,
    he continued participating in the tournament. Other knights left the tournament.
  • The winner of the last (the m-th) fight (the knight number xm)
    became the winner of the tournament.

You fished out all the information about the fights from your friends. Now for each knight you want to know the name of the knight he was conquered by. We think that the knight number b was
conquered by the knight number a, if there was a fight with both of these knights present and the winner was the knight number a.

Write the code that calculates for each knight, the name of the knight that beat him.

Input

The first line contains two integers nm (2 ≤ n ≤ 3·105; 1 ≤ m ≤ 3·105) —
the number of knights and the number of fights. Each of the following m lines contains three integers li, ri, xi (1 ≤ li < ri ≤ nli ≤ xi ≤ ri) —
the description of the i-th fight.

It is guaranteed that the input is correct and matches the problem statement. It is guaranteed that at least two knights took part in each battle.

Output

Print n integers. If the i-th
knight lost, then the i-th number should equal the number of the knight that beat the knight number i.
If the i-th knight is the winner, then the i-th
number must equal 0.

Sample test(s)
input
4 3
1 2 1
1 3 3
1 4 4
output
3 1 4 0 
input
8 4
3 5 4
3 7 6
2 8 8
1 8 1
output
0 8 4 6 4 8 6 1 
Note

Consider the first test case. Knights 1 and 2 fought the first fight and knight 1 won. Knights 1 and 3 fought the second fight and knight 3 won. The last fight was between knights 3 and 4, knight 4 won.

                 有感而发:当时第一题出的比较慢,但是总体还是稳住了脚。到最后才发现自己第一题写了点小bug,结果在最后一分钟交了一发,分数骤减,排名也掉了,rating也掉了。当时前两题,38分钟就过了,一直在卡第三题。但是当时思维比较短路,没有往STL上面考虑,一直想着能用比较好的方法,最后觉得是线段树,问了已经过了的茂茂,他说是线段树。但是下来了发现set就可以轻松地A掉。脑袋转的不灵活啊!

题目大意:题目意思是n,m,下面有m行,然后 每一行是 li ri xi,li到ri都会输给xi,让你输出i号人输给了谁,如果i没有输给其他人,那么他就是最终胜利的人,输出0.  主要就是这样li到ri。除了xi之外,更新为xi之后其它就不需要更新了。

解题思路:现在讲一下set的思路。开始把所有点都加进去,然后如果输掉了之后就把这点删掉,这样想的话,很easy...

题目地址:C. Knight Tournament
AC代码:
#include<iostream>
#include<cstdio>
#include<set>
using namespace std;

set <int> mq;
set <int>::iterator it,p[300005];
//p需要将开始的指针保存,便于删除

int res[300005];
int main()
{
    int n,m,i;
    int l,r,x;
    while(~scanf("%d%d",&n,&m))
    {
        mq.clear();
        for(i=1;i<=n;i++)
            mq.insert(i);  //先把所有的点都加进去
        while(m--)
        {
            scanf("%d%d%d",&l,&r,&x);
            it=mq.lower_bound(l);

            int tt=0;
            for(;*it<=r&&it!=mq.end();it++)
            {
                if(*it!=x)
                {
                    res[*it]=x;
                    p[tt++]=it;  //把需要删除的指针保存起来
                }
            }
            for(i=0;i<tt;i++)
                mq.erase(p[i]);
        }
        it=mq.begin();
        res[*it]=0;
        printf("%d",res[1]);
        for(i=2;i<=n;i++)
            printf(" %d",res[i]);
        printf("\n");
    }
    return 0;
}

抱歉!评论已关闭.